#include <iostream>
#include <cstring>
#include <stdlib.h>
#define size 500

using namespace std;
class Course {
	private:
		int id;
		int credit; 
		char* name;
	public:
		Course(){
			id = 0;
			credit = -1;
			name = NULL;
		}
		void setCourse(int i, int c , char *n){
			id = i;
			credit = c;
			name = n;
		}
		void print(){
			cout << id << " " << credit << " "<<name  << "\n";
		}
		char* getCourseName(){
			return name;
		}
		char getCredit(){
			return credit;
		}
		int getCourseId(){
			return id;
		}
};
class CourseGrade {
	private:
		Course* course;
		int grade; 
	public:
		CourseGrade(){
			course = NULL;
			grade = 0;
		}
		void setGrade(int cid,Course* list[1000],int g){
			int i;
			for (i=0;i<1000;i++){
				if (list[i]->getCourseId() == cid){
					course = list[i];
					grade = g;
					break;
				}
				
			}
			
		}
		// weighted
		int getGrade(){
			return course->getCredit()*grade;
		}

		int getCredit(){
			return course->getCredit();
		}
};
class Student {
	private:
		int id;
		char* name; 
		CourseGrade* cg[10];
	public:
		Student(){
			id = 0;
			name = NULL;
			for (int i=0;i<10;i++){
				cg[i]=NULL;
			}
		}
		void setStudent(int i, char *n){
			id = i;
			name = n;
		}
		void setGrade(int cid,Course* c_list[1000],int grade){
			for (int i=0;i<10;i++){
				if (cg[i] == NULL){
					//cg[i] is not used;
					cg[i] = new CourseGrade;
					cg[i]->setGrade(cid,c_list,grade);
					return;
				}
			}
		}
		char* getStudentName(){
			return name;
		}
		int getStudentId(){
			return id;
		}
		float average() {
	        int sum=0;
	        int sum_credit=0;
	        for(int i=0; i<10; i++) {

	            if(cg[i]!=NULL) {
	                sum+=cg[i]->getGrade();
	                sum_credit+=cg[i]->getCredit();
	            } else
	                break;
	        }
	        
	        float result=static_cast<float>(sum)/(sum_credit);
	        return result;
    	}

    	void showgarde(){
    		for (int i=0;i<10;i++){
    			if (cg[i]!=NULL){
    				cout << cg[i]->getGrade()<<" ";
    			}
    		}
    	}

};

void c_cut(char input[size],Course* list[1000]){
	//cut the course input
	int i=0;
	char delim []=",()";
	char* ptr = strtok(input,delim);
	while (ptr != NULL){
		int cid = atoi(ptr);
		ptr = strtok(NULL,delim);
		int credit = atoi(ptr);
		ptr = strtok(NULL,delim);
		char *name = ptr;
		ptr = strtok(NULL,delim);
		

		list[i] = new Course;
		list[i]->setCourse(cid,credit,name);
		i++;
	} 
}

void s_cut(char input[size],Student* list[1000]){
	//cut the student input
	int i=0;
	char delim[]=",()";
	char* ptr = strtok(input,delim);
	while (ptr != NULL){
		int sid = atoi(ptr);
		ptr = strtok(NULL,delim);
		char *name = ptr;
		ptr = strtok(NULL,delim);

		list[i] = new Student;
		list[i] -> setStudent(sid,name);
		i++;
	} 
}

int main(){
	int n=0;
	char c_input[size] = {0};
	Course* c_list[1000] = {0};
	cin >> n;
	cin.ignore();
	cin.getline(c_input,size);
	c_cut(c_input,c_list);

	int m=0;
	cin >> m;
	char s_input[size]={0};
	Student* s_list[1000]={0};
	cin.ignore();
	cin.getline(s_input,size);
	s_cut(s_input,s_list);

	//input score part
	int k;
	char cg_input[size]={0};
	cin >> k;
	cin.ignore();
	for (int i=0;i<k;i++){
		cin.getline(cg_input,size);
		char delim[] = " ,";
		char *ptr = strtok(cg_input,delim);
		while(ptr != NULL){
			int cid = atoi(ptr);
			ptr=strtok(NULL,delim);
			int sid = atoi(ptr);
			ptr=strtok(NULL,delim);
			int grade = atoi(ptr);
			ptr=strtok(NULL,delim);
			
			//find the user and set his grade
			for (int j=0;j<m;j++){
				if (s_list[j]->getStudentId() == sid){
					s_list[j]->setGrade(cid,c_list,grade);
				
				}
				
			}

		}
	}

	//input end
	//sort
	for (int i=0;i<m;i++){
		for (int j=0;j<m;j++){
			
			if (s_list[i]->average()>s_list[j]->average()){
				Student *tptr = s_list[i];
				s_list[i]=s_list[j];
				s_list[j] = tptr;
			}
			else if (s_list[i]->average() == s_list[j]->average()){
				if (strcmp(s_list[i]->getStudentName(),s_list[j]->getStudentName())<0){
					Student *tptr = s_list[i];
					s_list[i]=s_list[j];
					s_list[j] = tptr;
				}
			}
		}
	}


	//output
	for (int i=0;i<m;i++){
		cout << s_list[i]->getStudentName() <<"\t"<< s_list[i]->average()<<endl;
		if (i != m-1){
			cout << " ";
		}
	}
	
}