#include <iostream>
#include <cstring>
#include <stdlib.h>
#define size 500

using namespace std;
class Course {
	private:
		int id;
		int credit; 
		char* name;
	public:
		Course(){
			id = 0;
			credit = -1;
			name = NULL;
		}
		void setCourse(int i, int c , char *n){
			id = i;
			credit = c;
			name = n;
		}
		void print(){
			cout << id << " " << credit << " "<<name  << "\n";
		}
		char* getCourseName(){
			return name;
		}
		char getCredit(){
			return credit;
		}
		int getCourseId(){
			return id;
		}
};
class CourseGrade {
	private:
		Course* course;
		int grade; 
	public:
		CourseGrade(){
			course = NULL;
			grade = 0;
		}
		void setGrade(int cid,Course* list[1000],int g){
			int i;
			for (i=0;i<1000;i++){
				if (list[i]->getCourseId() == cid){
					course = list[i];
					grade = g;
					break;
				}
				
			}
			
		}
		int getCourseId(){
			return course->getCourseId();
		}

		//not weighted
		int getGrade(){
			return grade;
		}

		int getCredit(){
			return course->getCredit();
		}
};
class Student {
	private:
		int id;
		char* name; 
		CourseGrade* cg[10];
	public:
		Student(){
			id = 0;
			name = NULL;
			for (int i=0;i<10;i++){
				cg[i]=NULL;
			}
		}
		void setStudent(int i, char *n){
			id = i;
			name = n;
		}
		void print(){
			cout << id << "-" << name<<endl;
		}
		void setGrade(int cid,Course* c_list[1000],int grade){
			for (int i=0;i<10;i++){
				if (cg[i] == NULL){
					//not used;
					cg[i] = new CourseGrade;
					cg[i]->setGrade(cid,c_list,grade);
					return;
				}
			}
		}
		char* getStudentName(){
			return name;
		}
		int getStudentId(){
			return id;
		}
	
    	int getGrade(int cid){
    		for (int i=0;i<10;i++){
    			if (cg[i]==NULL){
    				return -1;
    				break;
    			}
    			if (cg[i]->getCourseId() == cid){
    				return cg[i]->getGrade();
    			}
    		}
    	}
    	void showgarde(){
    		for (int i=0;i<10;i++){
    			if (cg[i]!=NULL){
    				cout << cg[i]->getGrade()<<" ";
    			}
    		}
    	}

};

void c_cut(char input[size],Course* list[1000]){
	int i=0;
	char delim []=",()";
	char* ptr = strtok(input,delim);
	while (ptr != NULL){
		int cid = atoi(ptr);
		ptr = strtok(NULL,delim);
		int credit = atoi(ptr);
		ptr = strtok(NULL,delim);
		char *name = ptr;
		ptr = strtok(NULL,delim);
		
		list[i] = new Course;
		list[i]->setCourse(cid,credit,name);
		i++;
	} 
}

void s_cut(char input[size],Student* list[1000]){
	int i=0;
	char delim[]=",()";
	char* ptr = strtok(input,delim);
	while (ptr != NULL){
		int sid = atoi(ptr);
		ptr = strtok(NULL,delim);
		char *name = ptr;
		ptr = strtok(NULL,delim);

		list[i] = new Student;
		list[i] -> setStudent(sid,name);
		i++;
	} 
}

Student* find_student(Student* list[1000],int id){
	for (int i=0;i<1000;i++){
		if (list[i]->getStudentId() == id){
			return list[i];
		}
	}
}

bool dominate(Course* c_list[1000],Student* s1, Student* s2){
	//return true if s1 > s2
	for (int i=0;i<1000;i++){
		if (c_list[i] == NULL){
			break;
		}
		else{
			int myGrade = s1->getGrade(c_list[i]->getCourseId());
			int hisGrade = s2->getGrade(c_list[i]->getCourseId());
			
			if (myGrade <= hisGrade && hisGrade!=-1 && myGrade != -1){
				return false;
			}
			
		}
		
	}
	return true;
}

int main(){
	int n;
	char c_input[size] = {0};
	Course* c_list[1000] = {0};
	cin >> n;
	cin.ignore();
	cin.getline(c_input,size);
	c_cut(c_input,c_list);

	//input student
	int m;
	cin >> m;
	char s_input[size]={0};
	Student* s_list[1000]={0};
	cin.ignore();
	cin.getline(s_input,size);
	s_cut(s_input,s_list);

	

	//input grades
	int k;
	char cg_input[size]={0};
	cin >> k;
	cin.ignore();
	int cid,sid;
	for (int i=0;i<k;i++){
		
		cin.getline(cg_input,size);
		char delim[] = ",";
		char *ptr = strtok(cg_input,delim);
		while(ptr != NULL){
			//first, course
			if (isalpha(*ptr)){
				for(int j=0;j<n;j++){
					if (strcmp(c_list[j]->getCourseName(),ptr)==0){
						//same , found it!
						cid = c_list[j]->getCourseId();
						break;
					}
				}
			}
			else{
				cid = atoi(ptr);
			}

			//second, studnet
			ptr=strtok(NULL,delim);
			if (isalpha(*ptr)){
				for (int j=0;j<m;j++){
					if(strcmp(s_list[j]->getStudentName(),ptr)==0){
						sid = s_list[j]->getStudentId();
						break;
					}
				}
			}
			else{
				sid = atoi(ptr);
			}

			//third, grade
			ptr=strtok(NULL,delim);
			int grade = atoi(ptr);

			//find the user
			for (int j=0;j<m;j++){
				if (s_list[j]->getStudentId() == sid){
					s_list[j]->setGrade(cid,c_list,grade);
				}
				
			}
			ptr=strtok(NULL,delim);

		}
	}
	int target[100]={0};
	int p=0;
	while (cin >> target[p]){
		if (target[p]==0)
			break;
		p++;
	}
	Student* s1;
	Student* s2;
	int dominate_count=0;
	for (int i=0;i<p;i++){
		s1 = find_student(s_list,target[i]);
		for (int j=0;j<p;j++){
			if (i != j){
				s2 = find_student(s_list,target[j]);

				if (dominate(c_list,s1,s2)){
					dominate_count ++;
				}
			}
		}
	}

	cout << dominate_count<<endl;

	
}